(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('maddob-lib', ['exports', '@angular/core', '@angular/forms', '@angular/common'], factory) :
    (factory((global['maddob-lib'] = {}),global.ng.core,global.ng.forms,global.ng.common));
}(this, (function (exports,core,forms,common) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MarkdownEditorComponent = /** @class */ (function () {
        function MarkdownEditorComponent(required, maxlength) {
            if (required === void 0) {
                required = false;
            }
            if (maxlength === void 0) {
                maxlength = -1;
            }
            this.required = required;
            this.maxlength = maxlength;
            /**
             * flag for fullscreen mode
             */
            this.fullscreenEnabled = false;
            /**
             * flag for show/hide preview area
             */
            this.previewEnabled = true;
            /**
             * flag for disabling the editor (and all its controls)
             */
            this.disabled = false;
            this.onChange = ( /**
             * @param {?} newValue
             * @return {?}
             */function (newValue) { });
            this.onTouched = ( /**
             * @return {?}
             */function () { });
        }
        Object.defineProperty(MarkdownEditorComponent.prototype, "value", {
            get: /**
             * @return {?}
             */ function () {
                return this._value || '';
            },
            set: /**
             * @param {?} value
             * @return {?}
             */ function (value) {
                this._value = value;
                this.parsedHtml = marked(this._value);
                this.onChange(value);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        MarkdownEditorComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
            };
        /**
         * @return {?}
         */
        MarkdownEditorComponent.prototype.ngAfterViewInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.codeMirror = CodeMirror.fromTextArea(this.editor.nativeElement, {
                    mode: 'markdown',
                    lineNumbers: true,
                    autoCloseTags: true,
                    lineWrapping: true,
                    extraKeys: { 'Ctrl-Space': 'autocomplete' }
                });
                this.codeMirror.doc.on('change', ( /**
                 * @param {?} instance
                 * @param {?} change
                 * @return {?}
                 */function (instance, change) {
                    _this.value = instance.getValue();
                }));
                this.resizeCodeMirror();
            };
        /* ControlValueAccessor methods  */
        /* ControlValueAccessor methods  */
        /**
         * @param {?} obj
         * @return {?}
         */
        MarkdownEditorComponent.prototype.writeValue = /* ControlValueAccessor methods  */
            /**
             * @param {?} obj
             * @return {?}
             */
            function (obj) {
                this._value = '';
                if (typeof obj === 'string' && this.codeMirror) {
                    this.codeMirror.setValue(obj);
                    this.onChange(obj);
                }
            };
        /**
         * @param {?} fn
         * @return {?}
         */
        MarkdownEditorComponent.prototype.registerOnChange = /**
         * @param {?} fn
         * @return {?}
         */
            function (fn) {
                this.onChange = fn;
            };
        /**
         * @param {?} fn
         * @return {?}
         */
        MarkdownEditorComponent.prototype.registerOnTouched = /**
         * @param {?} fn
         * @return {?}
         */
            function (fn) {
                this.onTouched = fn;
            };
        /**
         * @param {?} isDisabled
         * @return {?}
         */
        MarkdownEditorComponent.prototype.setDisabledState = /**
         * @param {?} isDisabled
         * @return {?}
         */
            function (isDisabled) {
                this.disabled = isDisabled;
                if (this.codeMirror) {
                    this.codeMirror.setOption('readOnly', isDisabled);
                }
            };
        /* END ControlValueAccessor methods  */
        /**
         * Validate implementation
         *
         * only required and maxlength for now
         */
        /* END ControlValueAccessor methods  */
        /**
         * Validate implementation
         *
         * only required and maxlength for now
         * @param {?} control
         * @return {?}
         */
        MarkdownEditorComponent.prototype.validate = /* END ControlValueAccessor methods  */
            /**
             * Validate implementation
             *
             * only required and maxlength for now
             * @param {?} control
             * @return {?}
             */
            function (control) {
                /** @type {?} */
                var result = null;
                if (this.required && this._value.length === 0) {
                    result = { required: true };
                }
                if (this.maxlength > 0 && this.value.length > this.maxlength) {
                    result = { maxlength: true };
                }
                return result;
            };
        /**
         * Resizes the code mirror instance to the size of the container
         *
         * Used when the code mirror editor element size is changed (window resize, )
         */
        /**
         * Resizes the code mirror instance to the size of the container
         *
         * Used when the code mirror editor element size is changed (window resize, )
         * @return {?}
         */
        MarkdownEditorComponent.prototype.resizeCodeMirror = /**
         * Resizes the code mirror instance to the size of the container
         *
         * Used when the code mirror editor element size is changed (window resize, )
         * @return {?}
         */
            function () {
                var _this = this;
                setTimeout(( /**
                 * @return {?}
                 */function () {
                    /** @type {?} */
                    var editorContainer = _this.editor.nativeElement.parentNode;
                    _this.codeMirror.setSize(editorContainer.offsetWidth, editorContainer.offsetHeight);
                }), 200);
            };
        /**
         * @return {?}
         */
        MarkdownEditorComponent.prototype.toggleFullscreen = /**
         * @return {?}
         */
            function () {
                this.fullscreenEnabled = !this.fullscreenEnabled;
                this.resizeCodeMirror();
            };
        /**
         * @return {?}
         */
        MarkdownEditorComponent.prototype.togglePreview = /**
         * @return {?}
         */
            function () {
                this.previewEnabled = !this.previewEnabled;
                this.resizeCodeMirror();
            };
        /**
         * Inserts special content into the editor
         *
         * can be used for different buttons like bold, italic,
         *
         * Override the method if you want to customize the behaviour of the
         * insertion. For example if you have an own image selector and so on.
         *
         * @param type type of the content that is to be inserted
         * @param value optional value (for special custom content)
         */
        /**
         * Inserts special content into the editor
         *
         * can be used for different buttons like bold, italic,
         *
         * Override the method if you want to customize the behaviour of the
         * insertion. For example if you have an own image selector and so on.
         *
         * @param {?} type type of the content that is to be inserted
         * @param {?=} value optional value (for special custom content)
         * @return {?}
         */
        MarkdownEditorComponent.prototype.insertContent = /**
         * Inserts special content into the editor
         *
         * can be used for different buttons like bold, italic,
         *
         * Override the method if you want to customize the behaviour of the
         * insertion. For example if you have an own image selector and so on.
         *
         * @param {?} type type of the content that is to be inserted
         * @param {?=} value optional value (for special custom content)
         * @return {?}
         */
            function (type, value) {
                /** @type {?} */
                var from = this.codeMirror.getCursor('from');
                // if value is set, use it, if not get the selection instead
                /** @type {?} */
                var selection = value ? value : this.codeMirror.getSelection();
                /** @type {?} */
                var to = this.codeMirror.getCursor('to');
                /** @type {?} */
                var newCursorPosition = { line: to.line, ch: to.ch };
                /** @type {?} */
                var additionalOffset = 0;
                /** @type {?} */
                var replacement = '';
                switch (type) {
                    case 'bold':
                        replacement = "**" + selection + "**";
                        this.codeMirror.replaceRange(replacement, from, to);
                        additionalOffset = 2;
                        break;
                    case 'italic':
                        replacement = "*" + selection + "*";
                        this.codeMirror.replaceRange(replacement, from, to);
                        additionalOffset = 1;
                        break;
                    case 'quote':
                        replacement = "> " + this.codeMirror.getLine(from.line);
                        this.codeMirror.replaceRange(replacement, { line: from.line, ch: 0 }, { line: from.line, ch: replacement.length });
                        break;
                    case 'list':
                        replacement = "- " + this.codeMirror.getLine(from.line);
                        this.codeMirror.replaceRange(replacement, { line: from.line, ch: 0 }, { line: from.line, ch: replacement.length });
                        break;
                    case 'link':
                        replacement = "[](" + selection + ")";
                        this.codeMirror.replaceRange(replacement, from, to);
                        additionalOffset = 1;
                        break;
                    case 'image':
                        replacement = "![](" + selection + ")";
                        this.codeMirror.replaceRange(replacement, from, to);
                        additionalOffset = 2;
                        break;
                    case 'code':
                        replacement = "```\r\n" + selection + "\r\n```";
                        this.codeMirror.replaceRange(replacement, from, to);
                        additionalOffset = 4;
                        break;
                    default:
                }
                newCursorPosition.ch += replacement.length - selection.length - additionalOffset;
                this.codeMirror.setCursor(newCursorPosition);
                this.codeMirror.focus();
                this.onChange(this._value);
            };
        MarkdownEditorComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'maddob-markdown-editor',
                        template: "<div class=\"maddob-markdown-editor-container\" [ngClass]=\"{'fullscreen': fullscreenEnabled}\">\n  \n    <!-- HEADER -->\n    <div class=\"maddob-markdown-editor-header\">\n  \n      <div class=\"maddob-markdown-editor-left\">\n        <button [disabled]=\"disabled\" (click)=\"insertContent('bold')\">bold</button>\n        <button [disabled]=\"disabled\" (click)=\"insertContent('italic')\">italic</button>\n        <button [disabled]=\"disabled\" (click)=\"insertContent('quote')\">quote</button>\n        <button [disabled]=\"disabled\" (click)=\"insertContent('code')\">code</button>\n      </div>\n  \n      <div class=\"maddob-markdown-editor-center\">\n          <button [disabled]=\"disabled\"  (click)=\"insertContent('list')\">list</button>\n          <button [disabled]=\"disabled\"  (click)=\"insertContent('link')\">link</button>\n          <button [disabled]=\"disabled\"  (click)=\"insertContent('image')\">image</button>\n        </div>\n  \n      <div class=\"maddob-markdown-editor-right\">\n        <button (click)=\"togglePreview()\">preview on</button>\n        <button (click)=\"toggleFullscreen()\">fullscreen</button>\n      </div>\n      \n    </div>\n  \n    <!-- CONTENT -->\n    <div class=\"maddob-markdown-editor-content\">\n  \n      <div class=\"maddob-markdown-editor\" (window:resize)=\"resizeCodeMirror()\"\n        [ngClass]=\"{'default-height': !fullscreenEnabled, 'full-height': fullscreenEnabled}\">\n          <textarea #editor></textarea>\n      </div>\n  \n      <div class=\"maddob-markdown-preview\" [innerHTML]=\"parsedHtml\" *ngIf=\"previewEnabled\"\n        [ngClass]=\"{'default-height': !fullscreenEnabled, 'full-height': fullscreenEnabled}\">\n      </div>\n  \n    </div>\n  </div>\n  ",
                        providers: [
                            {
                                provide: forms.NG_VALUE_ACCESSOR,
                                multi: true,
                                useExisting: core.forwardRef(( /**
                                 * @return {?}
                                 */function () { return MarkdownEditorComponent; })),
                            },
                            {
                                provide: forms.NG_VALIDATORS,
                                multi: true,
                                useExisting: core.forwardRef(( /**
                                 * @return {?}
                                 */function () { return MarkdownEditorComponent; }))
                            }
                        ],
                        styles: [".maddob-markdown-editor-container{display:flex;flex-direction:column;border:1px solid #000}.maddob-markdown-editor-header{display:flex;flex-direction:row;justify-content:space-between;padding:5px}.maddob-markdown-editor-header-left{display:flex;justify-content:flex-start}.maddob-markdown-editor-header-center{flex-grow:0;display:flex;justify-content:center}.maddob-markdown-editor-header-right{display:flex;justify-content:flex-end}.maddob-markdown-editor-content{display:flex;flex-grow:1;flex-direction:row;border-top:1px solid #000}.maddob-markdown-editor{flex-basis:50%;flex-grow:1;text-align:left;overflow:scroll}.maddob-markdown-editor textarea{width:100%;height:100%}.maddob-markdown-preview{text-align:left;flex-basis:50%;border-left:1px solid #ccc;overflow:scroll;padding:5px}.default-height{height:300px}.full-height{height:100%}.fullscreen{background-color:#fff;height:100%;width:100%;left:0;top:0;overflow:hidden;position:fixed;z-index:1000}"]
                    }] }
        ];
        /** @nocollapse */
        MarkdownEditorComponent.ctorParameters = function () {
            return [
                { type: Boolean, decorators: [{ type: core.Attribute, args: ['required',] }] },
                { type: Number, decorators: [{ type: core.Attribute, args: ['maxlength',] }] }
            ];
        };
        MarkdownEditorComponent.propDecorators = {
            editor: [{ type: core.ViewChild, args: ["editor",] }]
        };
        return MarkdownEditorComponent;
    }());

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var UikitMarkdownEditorComponent = /** @class */ (function (_super) {
        __extends(UikitMarkdownEditorComponent, _super);
        function UikitMarkdownEditorComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * @return {?}
         */
        UikitMarkdownEditorComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
            };
        /**
         * @return {?}
         */
        UikitMarkdownEditorComponent.prototype.resizeCodeMirror = /**
         * @return {?}
         */
            function () {
                var _this = this;
                setTimeout(( /**
                 * @return {?}
                 */function () {
                    /** @type {?} */
                    var editorContainer = _this.editor.nativeElement.parentNode;
                    _this.codeMirror.setSize(editorContainer.offsetWidth - 50, editorContainer.offsetHeight);
                }), 200);
            };
        UikitMarkdownEditorComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'maddob-uikit-markdown-editor',
                        template: "<div [ngClass]=\"{'fullscreen': fullscreenEnabled}\" class=\"full-border\">\n  <div class=\"CodeMirror-Editor-Tab uk-background-muted uk-flex\">\n    <div class=\"uk-flex uk-flex-left\">\n      <a uk-icon=\"icon: bold\" (click)=\"insertContent('bold')\" uk-tooltip=\"title: Bold; delay: 800\"></a>\n      <a uk-icon=\"icon: italic\" (click)=\"insertContent('italic')\" uk-tooltip=\"title: Italic; delay: 800\"></a>\n      <a uk-icon=\"icon: quote-right\" (click)=\"insertContent('quote')\" uk-tooltip=\"title: Blockquote; delay: 800\"></a>\n    </div>\n\n    <div class=\"uk-flex uk-flex-left uk-margin-left separator\"></div>\n\n    <div class=\"uk-flex uk-flex-left uk-margin-left\">\n      <a uk-icon=\"icon: list\" (click)=\"insertContent('list')\" uk-tooltip=\"title: List; delay: 800\"></a>\n      <a uk-icon=\"icon: code\" (click)=\"insertContent('code')\" uk-tooltip=\"title: Code; delay: 800\"></a>\n    </div>\n\n    <div class=\"uk-flex uk-flex-left uk-margin-left separator\"></div>\n\n    <div class=\"uk-flex uk-flex-left uk-margin-left\">\n      <a uk-icon=\"icon: link\" (click)=\"insertContent('link')\" uk-tooltip=\"title: Link; delay: 800\"></a>\n      <a uk-icon=\"icon: image\" (click)=\"insertContent('image')\" uk-tooltip=\"title: image; delay: 800\"></a>\n    </div>\n\n    <div class=\"uk-flex uk-flex-left uk-margin-left separator\"></div>\n\n    <div class=\"uk-flex uk-flex-left uk-margin-left\">\n      <a *ngIf=\"previewEnabled\" uk-icon=\"icon: chevron-right\" (click)=\"previewEnabled = false; resizeCodeMirror()\"></a>\n      <a *ngIf=\"!previewEnabled\" uk-icon=\"icon: chevron-left\" (click)=\"previewEnabled = true; resizeCodeMirror()\"></a>\n    </div>\n\n    <div class=\"uk-flex uk-flex-right\" style=\"flex-grow: 1;\">\n      <a *ngIf=\"!fullscreenEnabled\" uk-icon=\"icon: expand\" (click)=\"toggleFullscreen()\"></a>\n      <a *ngIf=\"fullscreenEnabled\" uk-icon=\"icon: shrink\" (click)=\"toggleFullscreen()\"></a>\n    </div>\n  </div>\n\n\n  <div class=\"editor-content\" class=\"uk-grid\" uk-grid\n    [ngClass]=\"{'max-height': !fullscreenEnabled, 'full-height': fullscreenEnabled}\">\n    <div class=\"code-mirror-container\"\n      [ngClass]=\"{'uk-width-1-2': previewEnabled, 'uk-width-expand': !previewEnabled, 'max-height': !fullscreenEnabled}\"\n      #codeMirrorContainer (window:resize)=\"resizeCodeMirror()\">\n      <textarea #editor name=\"content\"></textarea>\n    </div>\n    <div *ngIf=\"previewEnabled\" class=\"preview\" [ngClass]=\"{'uk-width-1-2': previewEnabled, 'hidden': !previewEnabled }\"\n      [innerHTML]=\"parsedHtml\"></div>\n  </div>\n</div>",
                        providers: [
                            {
                                provide: forms.NG_VALUE_ACCESSOR,
                                multi: true,
                                useExisting: core.forwardRef(( /**
                                 * @return {?}
                                 */function () { return UikitMarkdownEditorComponent; })),
                            },
                            {
                                provide: forms.NG_VALIDATORS,
                                multi: true,
                                useExisting: core.forwardRef(( /**
                                 * @return {?}
                                 */function () { return UikitMarkdownEditorComponent; }))
                            }
                        ],
                        styles: [".full-border,.html-editor-container{border:1px solid #e5e5e5}.CodeMirror-Editor-Tab{padding:10px;border-bottom:1px solid #e5e5e5}.editor-content{border:1px solid #e5e5e5}.fullscreen{height:100%;width:100%;left:0;top:0;overflow:hidden;position:fixed;z-index:1000}.preview{overflow:scroll;overflow-wrap:break-word;border-left:1px solid #e5e5e5;height:300px;padding:5px}.hidden{display:none}.max-height{height:300px;overflow:scroll}.full-height,.full-height textarea,.full-height>.uk-width-1-2>.CodeMirror{height:100%}.full-height div{height:100%;background-color:#fff;display:block}#preview-content{background:#fff;padding:5px}.uk-icon{padding:0 5px}.separator{width:1px;background-color:#e5e5e5}"]
                    }] }
        ];
        return UikitMarkdownEditorComponent;
    }(MarkdownEditorComponent));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MaddobLibModule = /** @class */ (function () {
        function MaddobLibModule() {
        }
        MaddobLibModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [MarkdownEditorComponent, UikitMarkdownEditorComponent],
                        imports: [
                            common.CommonModule,
                            forms.FormsModule
                        ],
                        exports: [MarkdownEditorComponent, UikitMarkdownEditorComponent]
                    },] }
        ];
        return MaddobLibModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.MarkdownEditorComponent = MarkdownEditorComponent;
    exports.UikitMarkdownEditorComponent = UikitMarkdownEditorComponent;
    exports.MaddobLibModule = MaddobLibModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=maddob-lib.umd.js.map